﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.Map;

namespace ClickDataPoint
{
    public partial class MainPage : UserControl
    {
        private MapDataModel mapModel = new MapDataModel();

        public MainPage()
        {
            InitializeComponent();

            this.DataContext = this.mapModel;
            this.CreateDataPoints();
        }

        private void CreateDataPoints()
        {
            this.CreatePointsInRect(100);
        }

        private void CreatePointsInRect(int count)
        {
            Random rnd = new Random();

            // region for generating sample data
            LocationRect rect = new LocationRect(
                new Location(45, -100),
                new Location(35, -90));

            // creates points in the view model
            for (int i = 0; i < count; i++)
            {
                Location location = new Location(
                    rect.North - rect.GeoSize.Height * rnd.NextDouble(),
                    rect.West + rect.GeoSize.Width * rnd.NextDouble());

                DataPoint poi = new DataPoint()
                {
                    Id = i,
                    Location = location
                };

                this.mapModel.Points.Add(poi);
            }
        }

        private void PointMouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            FrameworkElement element = sender as FrameworkElement;
            if (element != null)
            {
                DataPoint point = element.DataContext as DataPoint;
                if (point != null)
                {
                    int pointId = point.Id;

                    MessageBox.Show("Point id is " + pointId, "DataPoint", MessageBoxButton.OK);

                    // prevent the map control to move on the location by click
                    e.Handled = true;
                }
            }
        }
    }
}
